package com.zt.plat.module.qms.business.config.service;

import cn.hutool.core.collection.CollUtil;
import com.zt.plat.module.qms.business.config.controller.vo.ConfigReportTemplatePageReqVO;
import com.zt.plat.module.qms.business.config.controller.vo.ConfigReportTemplateRespVO;
import com.zt.plat.module.qms.business.config.controller.vo.ConfigReportTemplateSaveReqVO;
import org.springframework.stereotype.Service;
import jakarta.annotation.Resource;
import org.springframework.validation.annotation.Validated;

import com.baomidou.mybatisplus.core.toolkit.Wrappers;

import java.util.*;

import com.zt.plat.module.qms.business.config.dal.dataobject.ConfigReportTemplateDO;
import com.zt.plat.framework.common.pojo.PageResult;
import com.zt.plat.framework.common.util.object.BeanUtils;

import com.zt.plat.module.qms.business.config.dal.mapper.ConfigReportTemplateMapper;
import com.zt.plat.module.qms.enums.QmsCommonConstant;
import com.zt.plat.module.qms.framework.gridreport.GridReport;

import static com.zt.plat.framework.common.exception.util.ServiceExceptionUtil.exception;
import static com.zt.plat.module.qms.enums.ErrorCodeConstants.*;

/**
 * 报表模版配置 Service 实现类
 *
 * @author 后台管理
 */
@Service
@Validated
public class ConfigReportTemplateServiceImpl implements ConfigReportTemplateService {

    @Resource
    private ConfigReportTemplateMapper configReportTemplateMapper;

    @Override
    public ConfigReportTemplateRespVO createConfigReportTemplate(ConfigReportTemplateSaveReqVO createReqVO) {
        // 插入
        ConfigReportTemplateDO configReportTemplate = BeanUtils.toBean(createReqVO, ConfigReportTemplateDO.class);
        String content = configReportTemplate.getContent();
        if (content.startsWith(GridReport.WR_PREFIX)) {
        	configReportTemplate.setIsAuthority(1);
		}
        configReportTemplate.setIsLast(QmsCommonConstant.YES);
        
        configReportTemplateMapper.insert(configReportTemplate);
        // 返回
        return BeanUtils.toBean(configReportTemplate, ConfigReportTemplateRespVO.class);
    }

    @Override
    public void updateConfigReportTemplate(ConfigReportTemplateSaveReqVO updateReqVO) {
        // 校验存在
        validateConfigReportTemplateExists(updateReqVO.getId());
        // 更新
        ConfigReportTemplateDO updateObj = BeanUtils.toBean(updateReqVO, ConfigReportTemplateDO.class);
        String content = updateObj.getContent();
        if (content.startsWith(GridReport.WR_PREFIX)) {
        	updateObj.setIsAuthority(1);
		}
        configReportTemplateMapper.updateById(updateObj);
    }

    @Override
    public void deleteConfigReportTemplate(Long id) {
        // 校验存在
        validateConfigReportTemplateExists(id);
        // 删除
        configReportTemplateMapper.deleteById(id);
    }

    @Override
        public void deleteConfigReportTemplateListByIds(List<Long> ids) {
        // 校验存在
        validateConfigReportTemplateExists(ids);
        // 删除
        configReportTemplateMapper.deleteByIds(ids);
        }

    private void validateConfigReportTemplateExists(List<Long> ids) {
        List<ConfigReportTemplateDO> list = configReportTemplateMapper.selectByIds(ids);
        if (CollUtil.isEmpty(list) || list.size() != ids.size()) {
            throw exception(CONFIG_REPORT_TEMPLATE_NOT_EXISTS);
        }
    }

    private void validateConfigReportTemplateExists(Long id) {
        if (configReportTemplateMapper.selectById(id) == null) {
            throw exception(CONFIG_REPORT_TEMPLATE_NOT_EXISTS);
        }
    }

    @Override
    public ConfigReportTemplateDO getConfigReportTemplate(Long id) {
        return configReportTemplateMapper.selectById(id);
    }

    @Override
    public PageResult<ConfigReportTemplateDO> getConfigReportTemplatePage(ConfigReportTemplatePageReqVO pageReqVO) {
        return configReportTemplateMapper.selectPage(pageReqVO);
    }

	@Override
	public ConfigReportTemplateDO getConfigReportTemplateByKey(String reportKey) {
		return configReportTemplateMapper.selectOne(Wrappers.<ConfigReportTemplateDO>query().lambda().eq(ConfigReportTemplateDO::getKey, reportKey));
	}

}